#[allow(dead_code)]
mod bit_utilities;

use bit_utilities as bu;
use text_io::read;

fn input_handler(first_register: bu::BasicRegister, second_register: bu::BasicRegister) {
    let (first_register, second_register) = bu::align_registers(first_register, second_register);

    println!();
    println!("First register:\n{}", first_register.table());
    println!("Second register:\n{}", second_register.table());

    loop {
        print!("\nChoose the operation:\n[a]ddition, [s]ubtraction, [m]ultiplication, [d]ivision, [q]uit\n>>> ");
        let input: String = read!();
        match input.as_str() {
            "a" => {
                let sum: bu::BasicRegister = bu::binary_sum(&first_register, &second_register);
                println!("Sum:\n{}\nResult (to copy): {sum:b}", sum.table())
            }
            "s" => {
                let difference: bu::BasicRegister = bu::binary_subtraction(&first_register, &second_register);
                println!("Difference:\n{}\nResult (to copy): {difference:b}", difference.table())
            }
            "m" => (),
            "d" => (),
            "q" => std::process::exit(0x0100),
            _ => println!("Not an available operation, try again."),
        }
    }
}

fn main() {
    let reg = bu::BasicRegister::new(bu::get_memory("your number"));
    let reg2 = bu::BasicRegister::new(bu::get_memory("your number"));

    input_handler(reg, reg2);
}
